/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef JAC_AP_EMSERVICE_EMSERVICE_PROXY_H
#define JAC_AP_EMSERVICE_EMSERVICE_PROXY_H

#include "ara/com/internal/proxy/proxy_adapter.h"
#include "ara/com/internal/proxy/event_adapter.h"
#include "ara/com/internal/proxy/field_adapter.h"
#include "ara/com/internal/proxy/method_adapter.h"
#include "ara/com/crc_verification.h"
#include "jac/ap/emservice/emservice_common.h"
#include <string>

namespace jac {
namespace ap {
namespace emservice {
namespace proxy {
namespace events {
    using TargetsInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::TargetsInfo>;
    using TargetInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::TargetInfo>;
    using RoadEdgeInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RoadEdgeInfo>;
    using LaneMarkerInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LaneMarkerInfo>;
    using RoadInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RoadInfo>;
    using RMHeaderEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RMHeader>;
    using IndexEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::Index>;
    using CarPositionEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::CarPosition>;
    using LaneEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::Lane>;
    using LaneMarkerEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LaneMarker>;
    using ObjectEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::Object>;
    using RoadEdgeEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RoadEdge>;
    using NeighborLaneEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::NeighborLane>;
    using CorridorEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::Corridor>;
    using SamplingPointEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::SamplingPoint>;
    using LineColorEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LineColor>;
    using LineTypeEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LineType>;
    using ObjectLocationEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::ObjectLocation>;
    using SLPointEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::SLPoint>;
    using LaneControlEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LaneControl>;
    using LaneBoundryEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LaneBoundary>;
    using LineGeometryEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LineGeometry>;
    using RoadEdgeSegmentEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RoadEdgeSegment>;
    using LaneInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LaneInfo>;
    using LeftLineEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LeftLine>;
    using RightLineEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RightLine>;
    using RightRoadEdgeEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RightRoadEdge>;
    using LeftRoadEdgeEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::LeftRoadEdge>;
    using ODDInfoEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::ODDInfo>;
    using RMEgoLftLnegeometryEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RMEgoLftLnegeometry>;
    using RMEgoRgtLnegeometryEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RMEgoRgtLnegeometry>;
    using RMRdEdgeLftgeometryEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RMRdEdgeLftgeometry>;
    using RMRdEdgeRgtgeometryEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RMRdEdgeRgtgeometry>;
    using RMSMMessageEvent = ara::com::internal::proxy::event::EventAdapter<::dpc::RMSMMessage>;
    static constexpr ara::com::internal::EntityId EMServiceTargetsInfoEventId = 16631U; //TargetsInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceTargetInfoEventId = 28852U; //TargetInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRoadEdgeInfoEventId = 3862U; //RoadEdgeInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLaneMarkerInfoEventId = 51141U; //LaneMarkerInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRoadInfoEventId = 56244U; //RoadInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRMHeaderEventId = 10987U; //RMHeaderEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceIndexEventId = 46526U; //IndexEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceCarPositionEventId = 37925U; //CarPositionEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLaneEventId = 41942U; //LaneEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLaneMarkerEventId = 53518U; //LaneMarkerEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceObjectEventId = 35544U; //ObjectEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRoadEdgeEventId = 62920U; //RoadEdgeEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceNeighborLaneEventId = 58173U; //NeighborLaneEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceCorridorEventId = 5591U; //CorridorEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceSamplingPointEventId = 16127U; //SamplingPointEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLineColorEventId = 62077U; //LineColorEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLineTypeEventId = 18174U; //LineTypeEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceObjectLocationEventId = 29095U; //ObjectLocationEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceSLPointEventId = 33687U; //SLPointEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLaneControlEventId = 8773U; //LaneControlEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLaneBoundryEventId = 32933U; //LaneBoundryEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLineGeometryEventId = 1163U; //LineGeometryEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRoadEdgeSegmentEventId = 64294U; //RoadEdgeSegmentEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLaneInfoEventId = 58013U; //LaneInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLeftLineEventId = 28186U; //LeftLineEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRightLineEventId = 10371U; //RightLineEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRightRoadEdgeEventId = 35493U; //RightRoadEdgeEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceLeftRoadEdgeEventId = 5664U; //LeftRoadEdgeEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceODDInfoEventId = 30927U; //ODDInfoEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRMEgoLftLnegeometryEventId = 10719U; //RMEgoLftLnegeometryEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRMEgoRgtLnegeometryEventId = 64259U; //RMEgoRgtLnegeometryEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRMRdEdgeLftgeometryEventId = 36597U; //RMRdEdgeLftgeometryEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRMRdEdgeRgtgeometryEventId = 35832U; //RMRdEdgeRgtgeometryEvent_event_hash
    static constexpr ara::com::internal::EntityId EMServiceRMSMMessageEventId = 52585U; //RMSMMessageEvent_event_hash
}

namespace fields {
}

namespace methods {

} // namespace methods

class EMServiceProxy {
private:
    std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
public:
    using HandleType = ara::com::HandleType;
    class ConstructionToken {
    public:
        explicit ConstructionToken(const std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> & proxy)
            : proxyAdapter(proxy),
              TargetsInfoEvent(proxyAdapter->GetProxy(), events::EMServiceTargetsInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              TargetInfoEvent(proxyAdapter->GetProxy(), events::EMServiceTargetInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RoadEdgeInfoEvent(proxyAdapter->GetProxy(), events::EMServiceRoadEdgeInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LaneMarkerInfoEvent(proxyAdapter->GetProxy(), events::EMServiceLaneMarkerInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RoadInfoEvent(proxyAdapter->GetProxy(), events::EMServiceRoadInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RMHeaderEvent(proxyAdapter->GetProxy(), events::EMServiceRMHeaderEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              IndexEvent(proxyAdapter->GetProxy(), events::EMServiceIndexEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              CarPositionEvent(proxyAdapter->GetProxy(), events::EMServiceCarPositionEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LaneEvent(proxyAdapter->GetProxy(), events::EMServiceLaneEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LaneMarkerEvent(proxyAdapter->GetProxy(), events::EMServiceLaneMarkerEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              ObjectEvent(proxyAdapter->GetProxy(), events::EMServiceObjectEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RoadEdgeEvent(proxyAdapter->GetProxy(), events::EMServiceRoadEdgeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              NeighborLaneEvent(proxyAdapter->GetProxy(), events::EMServiceNeighborLaneEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              CorridorEvent(proxyAdapter->GetProxy(), events::EMServiceCorridorEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              SamplingPointEvent(proxyAdapter->GetProxy(), events::EMServiceSamplingPointEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LineColorEvent(proxyAdapter->GetProxy(), events::EMServiceLineColorEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LineTypeEvent(proxyAdapter->GetProxy(), events::EMServiceLineTypeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              ObjectLocationEvent(proxyAdapter->GetProxy(), events::EMServiceObjectLocationEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              SLPointEvent(proxyAdapter->GetProxy(), events::EMServiceSLPointEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LaneControlEvent(proxyAdapter->GetProxy(), events::EMServiceLaneControlEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LaneBoundryEvent(proxyAdapter->GetProxy(), events::EMServiceLaneBoundryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LineGeometryEvent(proxyAdapter->GetProxy(), events::EMServiceLineGeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RoadEdgeSegmentEvent(proxyAdapter->GetProxy(), events::EMServiceRoadEdgeSegmentEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LaneInfoEvent(proxyAdapter->GetProxy(), events::EMServiceLaneInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LeftLineEvent(proxyAdapter->GetProxy(), events::EMServiceLeftLineEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RightLineEvent(proxyAdapter->GetProxy(), events::EMServiceRightLineEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RightRoadEdgeEvent(proxyAdapter->GetProxy(), events::EMServiceRightRoadEdgeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              LeftRoadEdgeEvent(proxyAdapter->GetProxy(), events::EMServiceLeftRoadEdgeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              ODDInfoEvent(proxyAdapter->GetProxy(), events::EMServiceODDInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RMEgoLftLnegeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMEgoLftLnegeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RMEgoRgtLnegeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMEgoRgtLnegeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RMRdEdgeLftgeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMRdEdgeLftgeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RMRdEdgeRgtgeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMRdEdgeRgtgeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              RMSMMessageEvent(proxyAdapter->GetProxy(), events::EMServiceRMSMMessageEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

        ConstructionToken(ConstructionToken&& other) = default;
        ConstructionToken& operator=(ConstructionToken && other) = default;

        ConstructionToken(const ConstructionToken&) = delete;
        ConstructionToken& operator = (const ConstructionToken&) = delete;
        
        virtual ~ConstructionToken() = default;

        /* Do not use such internal interfaces!!! */
        ara::core::Result<void> InitializeAll()
        {
            ara::core::Result<void> initResult;
            return initResult;
        }
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> GetProxyAdapter()
        {
            return proxyAdapter;
        }
        events::TargetsInfoEvent GetTargetsInfoEvent() noexcept { return std::move(TargetsInfoEvent); }
        events::TargetInfoEvent GetTargetInfoEvent() noexcept { return std::move(TargetInfoEvent); }
        events::RoadEdgeInfoEvent GetRoadEdgeInfoEvent() noexcept { return std::move(RoadEdgeInfoEvent); }
        events::LaneMarkerInfoEvent GetLaneMarkerInfoEvent() noexcept { return std::move(LaneMarkerInfoEvent); }
        events::RoadInfoEvent GetRoadInfoEvent() noexcept { return std::move(RoadInfoEvent); }
        events::RMHeaderEvent GetRMHeaderEvent() noexcept { return std::move(RMHeaderEvent); }
        events::IndexEvent GetIndexEvent() noexcept { return std::move(IndexEvent); }
        events::CarPositionEvent GetCarPositionEvent() noexcept { return std::move(CarPositionEvent); }
        events::LaneEvent GetLaneEvent() noexcept { return std::move(LaneEvent); }
        events::LaneMarkerEvent GetLaneMarkerEvent() noexcept { return std::move(LaneMarkerEvent); }
        events::ObjectEvent GetObjectEvent() noexcept { return std::move(ObjectEvent); }
        events::RoadEdgeEvent GetRoadEdgeEvent() noexcept { return std::move(RoadEdgeEvent); }
        events::NeighborLaneEvent GetNeighborLaneEvent() noexcept { return std::move(NeighborLaneEvent); }
        events::CorridorEvent GetCorridorEvent() noexcept { return std::move(CorridorEvent); }
        events::SamplingPointEvent GetSamplingPointEvent() noexcept { return std::move(SamplingPointEvent); }
        events::LineColorEvent GetLineColorEvent() noexcept { return std::move(LineColorEvent); }
        events::LineTypeEvent GetLineTypeEvent() noexcept { return std::move(LineTypeEvent); }
        events::ObjectLocationEvent GetObjectLocationEvent() noexcept { return std::move(ObjectLocationEvent); }
        events::SLPointEvent GetSLPointEvent() noexcept { return std::move(SLPointEvent); }
        events::LaneControlEvent GetLaneControlEvent() noexcept { return std::move(LaneControlEvent); }
        events::LaneBoundryEvent GetLaneBoundryEvent() noexcept { return std::move(LaneBoundryEvent); }
        events::LineGeometryEvent GetLineGeometryEvent() noexcept { return std::move(LineGeometryEvent); }
        events::RoadEdgeSegmentEvent GetRoadEdgeSegmentEvent() noexcept { return std::move(RoadEdgeSegmentEvent); }
        events::LaneInfoEvent GetLaneInfoEvent() noexcept { return std::move(LaneInfoEvent); }
        events::LeftLineEvent GetLeftLineEvent() noexcept { return std::move(LeftLineEvent); }
        events::RightLineEvent GetRightLineEvent() noexcept { return std::move(RightLineEvent); }
        events::RightRoadEdgeEvent GetRightRoadEdgeEvent() noexcept { return std::move(RightRoadEdgeEvent); }
        events::LeftRoadEdgeEvent GetLeftRoadEdgeEvent() noexcept { return std::move(LeftRoadEdgeEvent); }
        events::ODDInfoEvent GetODDInfoEvent() noexcept { return std::move(ODDInfoEvent); }
        events::RMEgoLftLnegeometryEvent GetRMEgoLftLnegeometryEvent() noexcept { return std::move(RMEgoLftLnegeometryEvent); }
        events::RMEgoRgtLnegeometryEvent GetRMEgoRgtLnegeometryEvent() noexcept { return std::move(RMEgoRgtLnegeometryEvent); }
        events::RMRdEdgeLftgeometryEvent GetRMRdEdgeLftgeometryEvent() noexcept { return std::move(RMRdEdgeLftgeometryEvent); }
        events::RMRdEdgeRgtgeometryEvent GetRMRdEdgeRgtgeometryEvent() noexcept { return std::move(RMRdEdgeRgtgeometryEvent); }
        events::RMSMMessageEvent GetRMSMMessageEvent() noexcept { return std::move(RMSMMessageEvent); }
    private:
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
        events::TargetsInfoEvent TargetsInfoEvent;
        events::TargetInfoEvent TargetInfoEvent;
        events::RoadEdgeInfoEvent RoadEdgeInfoEvent;
        events::LaneMarkerInfoEvent LaneMarkerInfoEvent;
        events::RoadInfoEvent RoadInfoEvent;
        events::RMHeaderEvent RMHeaderEvent;
        events::IndexEvent IndexEvent;
        events::CarPositionEvent CarPositionEvent;
        events::LaneEvent LaneEvent;
        events::LaneMarkerEvent LaneMarkerEvent;
        events::ObjectEvent ObjectEvent;
        events::RoadEdgeEvent RoadEdgeEvent;
        events::NeighborLaneEvent NeighborLaneEvent;
        events::CorridorEvent CorridorEvent;
        events::SamplingPointEvent SamplingPointEvent;
        events::LineColorEvent LineColorEvent;
        events::LineTypeEvent LineTypeEvent;
        events::ObjectLocationEvent ObjectLocationEvent;
        events::SLPointEvent SLPointEvent;
        events::LaneControlEvent LaneControlEvent;
        events::LaneBoundryEvent LaneBoundryEvent;
        events::LineGeometryEvent LineGeometryEvent;
        events::RoadEdgeSegmentEvent RoadEdgeSegmentEvent;
        events::LaneInfoEvent LaneInfoEvent;
        events::LeftLineEvent LeftLineEvent;
        events::RightLineEvent RightLineEvent;
        events::RightRoadEdgeEvent RightRoadEdgeEvent;
        events::LeftRoadEdgeEvent LeftRoadEdgeEvent;
        events::ODDInfoEvent ODDInfoEvent;
        events::RMEgoLftLnegeometryEvent RMEgoLftLnegeometryEvent;
        events::RMEgoRgtLnegeometryEvent RMEgoRgtLnegeometryEvent;
        events::RMRdEdgeLftgeometryEvent RMRdEdgeLftgeometryEvent;
        events::RMRdEdgeRgtgeometryEvent RMRdEdgeRgtgeometryEvent;
        events::RMSMMessageEvent RMSMMessageEvent;
    };

    virtual ~EMServiceProxy()
    {
        TargetsInfoEvent.UnsetReceiveHandler();
        TargetsInfoEvent.Unsubscribe();
        TargetInfoEvent.UnsetReceiveHandler();
        TargetInfoEvent.Unsubscribe();
        RoadEdgeInfoEvent.UnsetReceiveHandler();
        RoadEdgeInfoEvent.Unsubscribe();
        LaneMarkerInfoEvent.UnsetReceiveHandler();
        LaneMarkerInfoEvent.Unsubscribe();
        RoadInfoEvent.UnsetReceiveHandler();
        RoadInfoEvent.Unsubscribe();
        RMHeaderEvent.UnsetReceiveHandler();
        RMHeaderEvent.Unsubscribe();
        IndexEvent.UnsetReceiveHandler();
        IndexEvent.Unsubscribe();
        CarPositionEvent.UnsetReceiveHandler();
        CarPositionEvent.Unsubscribe();
        LaneEvent.UnsetReceiveHandler();
        LaneEvent.Unsubscribe();
        LaneMarkerEvent.UnsetReceiveHandler();
        LaneMarkerEvent.Unsubscribe();
        ObjectEvent.UnsetReceiveHandler();
        ObjectEvent.Unsubscribe();
        RoadEdgeEvent.UnsetReceiveHandler();
        RoadEdgeEvent.Unsubscribe();
        NeighborLaneEvent.UnsetReceiveHandler();
        NeighborLaneEvent.Unsubscribe();
        CorridorEvent.UnsetReceiveHandler();
        CorridorEvent.Unsubscribe();
        SamplingPointEvent.UnsetReceiveHandler();
        SamplingPointEvent.Unsubscribe();
        LineColorEvent.UnsetReceiveHandler();
        LineColorEvent.Unsubscribe();
        LineTypeEvent.UnsetReceiveHandler();
        LineTypeEvent.Unsubscribe();
        ObjectLocationEvent.UnsetReceiveHandler();
        ObjectLocationEvent.Unsubscribe();
        SLPointEvent.UnsetReceiveHandler();
        SLPointEvent.Unsubscribe();
        LaneControlEvent.UnsetReceiveHandler();
        LaneControlEvent.Unsubscribe();
        LaneBoundryEvent.UnsetReceiveHandler();
        LaneBoundryEvent.Unsubscribe();
        LineGeometryEvent.UnsetReceiveHandler();
        LineGeometryEvent.Unsubscribe();
        RoadEdgeSegmentEvent.UnsetReceiveHandler();
        RoadEdgeSegmentEvent.Unsubscribe();
        LaneInfoEvent.UnsetReceiveHandler();
        LaneInfoEvent.Unsubscribe();
        LeftLineEvent.UnsetReceiveHandler();
        LeftLineEvent.Unsubscribe();
        RightLineEvent.UnsetReceiveHandler();
        RightLineEvent.Unsubscribe();
        RightRoadEdgeEvent.UnsetReceiveHandler();
        RightRoadEdgeEvent.Unsubscribe();
        LeftRoadEdgeEvent.UnsetReceiveHandler();
        LeftRoadEdgeEvent.Unsubscribe();
        ODDInfoEvent.UnsetReceiveHandler();
        ODDInfoEvent.Unsubscribe();
        RMEgoLftLnegeometryEvent.UnsetReceiveHandler();
        RMEgoLftLnegeometryEvent.Unsubscribe();
        RMEgoRgtLnegeometryEvent.UnsetReceiveHandler();
        RMEgoRgtLnegeometryEvent.Unsubscribe();
        RMRdEdgeLftgeometryEvent.UnsetReceiveHandler();
        RMRdEdgeLftgeometryEvent.Unsubscribe();
        RMRdEdgeRgtgeometryEvent.UnsetReceiveHandler();
        RMRdEdgeRgtgeometryEvent.Unsubscribe();
        RMSMMessageEvent.UnsetReceiveHandler();
        RMSMMessageEvent.Unsubscribe();

    }

    explicit EMServiceProxy(const HandleType &handle)
        : proxyAdapter(std::make_shared<ara::com::internal::proxy::ProxyAdapter>(::jac::ap::emservice::EMService::ServiceIdentifier, handle)),
          TargetsInfoEvent(proxyAdapter->GetProxy(), events::EMServiceTargetsInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          TargetInfoEvent(proxyAdapter->GetProxy(), events::EMServiceTargetInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RoadEdgeInfoEvent(proxyAdapter->GetProxy(), events::EMServiceRoadEdgeInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LaneMarkerInfoEvent(proxyAdapter->GetProxy(), events::EMServiceLaneMarkerInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RoadInfoEvent(proxyAdapter->GetProxy(), events::EMServiceRoadInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RMHeaderEvent(proxyAdapter->GetProxy(), events::EMServiceRMHeaderEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          IndexEvent(proxyAdapter->GetProxy(), events::EMServiceIndexEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          CarPositionEvent(proxyAdapter->GetProxy(), events::EMServiceCarPositionEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LaneEvent(proxyAdapter->GetProxy(), events::EMServiceLaneEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LaneMarkerEvent(proxyAdapter->GetProxy(), events::EMServiceLaneMarkerEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          ObjectEvent(proxyAdapter->GetProxy(), events::EMServiceObjectEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RoadEdgeEvent(proxyAdapter->GetProxy(), events::EMServiceRoadEdgeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          NeighborLaneEvent(proxyAdapter->GetProxy(), events::EMServiceNeighborLaneEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          CorridorEvent(proxyAdapter->GetProxy(), events::EMServiceCorridorEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          SamplingPointEvent(proxyAdapter->GetProxy(), events::EMServiceSamplingPointEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LineColorEvent(proxyAdapter->GetProxy(), events::EMServiceLineColorEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LineTypeEvent(proxyAdapter->GetProxy(), events::EMServiceLineTypeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          ObjectLocationEvent(proxyAdapter->GetProxy(), events::EMServiceObjectLocationEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          SLPointEvent(proxyAdapter->GetProxy(), events::EMServiceSLPointEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LaneControlEvent(proxyAdapter->GetProxy(), events::EMServiceLaneControlEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LaneBoundryEvent(proxyAdapter->GetProxy(), events::EMServiceLaneBoundryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LineGeometryEvent(proxyAdapter->GetProxy(), events::EMServiceLineGeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RoadEdgeSegmentEvent(proxyAdapter->GetProxy(), events::EMServiceRoadEdgeSegmentEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LaneInfoEvent(proxyAdapter->GetProxy(), events::EMServiceLaneInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LeftLineEvent(proxyAdapter->GetProxy(), events::EMServiceLeftLineEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RightLineEvent(proxyAdapter->GetProxy(), events::EMServiceRightLineEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RightRoadEdgeEvent(proxyAdapter->GetProxy(), events::EMServiceRightRoadEdgeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          LeftRoadEdgeEvent(proxyAdapter->GetProxy(), events::EMServiceLeftRoadEdgeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          ODDInfoEvent(proxyAdapter->GetProxy(), events::EMServiceODDInfoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RMEgoLftLnegeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMEgoLftLnegeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RMEgoRgtLnegeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMEgoRgtLnegeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RMRdEdgeLftgeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMRdEdgeLftgeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RMRdEdgeRgtgeometryEvent(proxyAdapter->GetProxy(), events::EMServiceRMRdEdgeRgtgeometryEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          RMSMMessageEvent(proxyAdapter->GetProxy(), events::EMServiceRMSMMessageEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

    void ThrowError(const ara::core::Result<void>& result) const
    {
        if (!(result.HasValue())) {
#ifndef NOT_SUPPORT_EXCEPTIONS
            ara::core::ErrorCode errorcode(result.Error());
            throw ara::com::ComException(std::move(errorcode));
#else
            std::cerr << "Error: Not support exception, create proxy failed!"<< std::endl;
#endif
        }
    }

    EMServiceProxy(const EMServiceProxy&) = delete;
    EMServiceProxy& operator=(const EMServiceProxy&) = delete;

    EMServiceProxy(EMServiceProxy&&) = default;
    EMServiceProxy& operator=(EMServiceProxy&&) = default;
    EMServiceProxy(ConstructionToken&& token) noexcept
        : proxyAdapter(token.GetProxyAdapter()),
          TargetsInfoEvent(token.GetTargetsInfoEvent()),
          TargetInfoEvent(token.GetTargetInfoEvent()),
          RoadEdgeInfoEvent(token.GetRoadEdgeInfoEvent()),
          LaneMarkerInfoEvent(token.GetLaneMarkerInfoEvent()),
          RoadInfoEvent(token.GetRoadInfoEvent()),
          RMHeaderEvent(token.GetRMHeaderEvent()),
          IndexEvent(token.GetIndexEvent()),
          CarPositionEvent(token.GetCarPositionEvent()),
          LaneEvent(token.GetLaneEvent()),
          LaneMarkerEvent(token.GetLaneMarkerEvent()),
          ObjectEvent(token.GetObjectEvent()),
          RoadEdgeEvent(token.GetRoadEdgeEvent()),
          NeighborLaneEvent(token.GetNeighborLaneEvent()),
          CorridorEvent(token.GetCorridorEvent()),
          SamplingPointEvent(token.GetSamplingPointEvent()),
          LineColorEvent(token.GetLineColorEvent()),
          LineTypeEvent(token.GetLineTypeEvent()),
          ObjectLocationEvent(token.GetObjectLocationEvent()),
          SLPointEvent(token.GetSLPointEvent()),
          LaneControlEvent(token.GetLaneControlEvent()),
          LaneBoundryEvent(token.GetLaneBoundryEvent()),
          LineGeometryEvent(token.GetLineGeometryEvent()),
          RoadEdgeSegmentEvent(token.GetRoadEdgeSegmentEvent()),
          LaneInfoEvent(token.GetLaneInfoEvent()),
          LeftLineEvent(token.GetLeftLineEvent()),
          RightLineEvent(token.GetRightLineEvent()),
          RightRoadEdgeEvent(token.GetRightRoadEdgeEvent()),
          LeftRoadEdgeEvent(token.GetLeftRoadEdgeEvent()),
          ODDInfoEvent(token.GetODDInfoEvent()),
          RMEgoLftLnegeometryEvent(token.GetRMEgoLftLnegeometryEvent()),
          RMEgoRgtLnegeometryEvent(token.GetRMEgoRgtLnegeometryEvent()),
          RMRdEdgeLftgeometryEvent(token.GetRMRdEdgeLftgeometryEvent()),
          RMRdEdgeRgtgeometryEvent(token.GetRMRdEdgeRgtgeometryEvent()),
          RMSMMessageEvent(token.GetRMSMMessageEvent()){
        static_cast<void>(std::move(token));
    }

    static ara::core::Result<ConstructionToken> Preconstruct(
        const ara::com::HandleType &handle)
    {
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> preProxyAdapter =
            std::make_shared<ara::com::internal::proxy::ProxyAdapter>(
               ::jac::ap::emservice::EMService::ServiceIdentifier, handle);
        ConstructionToken token{std::move(preProxyAdapter)};
        ara::core::Result<void> initResult {token.InitializeAll()};
        if (initResult.HasValue()) {
            return ara::core::Result<ConstructionToken>(std::move(token));
        } else {
            const ara::core::ErrorCode errorcode{initResult.Error()};
            ara::core::Result<EMServiceProxy::ConstructionToken> preResult{errorcode};
            return preResult;
        }
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType>& handler,
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::emservice::EMService::ServiceIdentifier, instance);
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType> handler,
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::emservice::EMService::ServiceIdentifier, specifier);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::emservice::EMService::ServiceIdentifier, instance);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::emservice::EMService::ServiceIdentifier, specifier);
    }

    static void StopFindService(const ara::com::FindServiceHandle& handle)
    {
        ara::com::internal::proxy::ProxyAdapter::StopFindService(handle);
    }

    HandleType GetHandle() const
    {
        return proxyAdapter->GetHandle();
    }
    bool SetEventThreadNumber(const std::uint16_t number, const std::uint16_t queueSize)
    {
        return proxyAdapter->SetEventThreadNumber(number, queueSize);
    }
    events::TargetsInfoEvent TargetsInfoEvent;
    events::TargetInfoEvent TargetInfoEvent;
    events::RoadEdgeInfoEvent RoadEdgeInfoEvent;
    events::LaneMarkerInfoEvent LaneMarkerInfoEvent;
    events::RoadInfoEvent RoadInfoEvent;
    events::RMHeaderEvent RMHeaderEvent;
    events::IndexEvent IndexEvent;
    events::CarPositionEvent CarPositionEvent;
    events::LaneEvent LaneEvent;
    events::LaneMarkerEvent LaneMarkerEvent;
    events::ObjectEvent ObjectEvent;
    events::RoadEdgeEvent RoadEdgeEvent;
    events::NeighborLaneEvent NeighborLaneEvent;
    events::CorridorEvent CorridorEvent;
    events::SamplingPointEvent SamplingPointEvent;
    events::LineColorEvent LineColorEvent;
    events::LineTypeEvent LineTypeEvent;
    events::ObjectLocationEvent ObjectLocationEvent;
    events::SLPointEvent SLPointEvent;
    events::LaneControlEvent LaneControlEvent;
    events::LaneBoundryEvent LaneBoundryEvent;
    events::LineGeometryEvent LineGeometryEvent;
    events::RoadEdgeSegmentEvent RoadEdgeSegmentEvent;
    events::LaneInfoEvent LaneInfoEvent;
    events::LeftLineEvent LeftLineEvent;
    events::RightLineEvent RightLineEvent;
    events::RightRoadEdgeEvent RightRoadEdgeEvent;
    events::LeftRoadEdgeEvent LeftRoadEdgeEvent;
    events::ODDInfoEvent ODDInfoEvent;
    events::RMEgoLftLnegeometryEvent RMEgoLftLnegeometryEvent;
    events::RMEgoRgtLnegeometryEvent RMEgoRgtLnegeometryEvent;
    events::RMRdEdgeLftgeometryEvent RMRdEdgeLftgeometryEvent;
    events::RMRdEdgeRgtgeometryEvent RMRdEdgeRgtgeometryEvent;
    events::RMSMMessageEvent RMSMMessageEvent;
};
} // namespace proxy
} // namespace emservice
} // namespace ap
} // namespace jac

#endif // JAC_AP_EMSERVICE_EMSERVICE_PROXY_H
